/* ---rgf, 2015-07-15 */

parse source opsys calltype path2this

if opsys~left(1)<>"W" then
do
   say "this utility runs on Windows only, found:" pp(opsys)", aborting"
   exit -1
end

location=filespec("location",path2this)
location=location~left(location~length-1) -- remove trailing slash


parse version ')_' bitness '-bit '
if bitness="" then
do
   say 'bitness cannot be determined from PARSE VERSION, please use ooRexx 4.2.0 or higher, aborting'
   exit -2
end

if '32 64'~wordpos(bitness)=0 then
do
   say 'bitness ['||bitness'] not "32" or "64", aborting'
   exit -3
end


   -- add location of this setup program to PATH
add2path=quote(location)";"quote(location"\"||bitness)

   -- determine Java version, minimum of 1.6 needed (using JSR-223/javax.script)
javaVersion=getJavaHome(location, "java.version")
if javaVersion<1.6 then
do
   say "need Java version 1.6 or higher (needs package 'javax.script'), current Java version:" javaVersion", aborting..."
   exit -4
end

   -- determine home of Java add path to jvm.dll to use (JAVA_HOME/jre/bin/client)
javaHome=getJavaHome(location)
javaBin=quote(javaHome"\bin")
jvmDll=quote(javaHome"\bin\client")
add2path=add2path";"jvmDll -- ";"javaBin

   -- add location of this setup program to CLASSPATH
call sysFileTree location"\*.jar", "jars.", "FO"
add2classPath=""
do i=1 to jars.0
   if add2classPath="" then add2classPath=quote(jars.i)
                       else add2classPath=add2classPath";"quote(jars.i)
end

add2classPath=add2classpath";"quote(location)";."

   -- create setEnv.cmd script
f=.stream~new(location"\setEnv.cmd")~~open("Replace")
f~say("@echo off")
f~say("rem created on:" .dateTime~new)
f~say("set PATH="add2path";%PATH%")
f~say

if value("CLASSPATH",,"ENVIRONMENT")="" then
   f~say("set CLASSPATH="add2classPath)
else
   f~say("set CLASSPATH="add2classPath";%CLASSPATH%")

f~say
f~say("echo      PATH=%PATH%")
f~say("echo .")
f~say("echo CLASSPATH=%CLASSPATH%")
f~close

say f": created successfully, run to set environment appropriately"


::routine quote      -- quote only, if there is a space in the suplied path
  parse arg arg1
  if pos(" ",arg1)>0 then
     return '"' || arg1 || '"'
  return arg1

::routine getJavaHome
  parse arg location, property

  command="java -cp" quote(location) "GetJavaHome"
  if property<>"" then     -- a Java property supplied ?
     command=command property

  command=command "| rxqueue"
  command      -- execute command

  parse pull val  -- fetch output of Java program
  return val   -- return Java property value


::routine pp
  return "["arg(1)"]"
